/*
 * Get current cycles counter value by ClockCycles() kernel call.
 * Print time passed from board start
 *
 * (c) 2019, SWD Embedded Systems Limited, http://www.kpda.ru
 */


#include <stdio.h>
#include <unistd.h>
#include <stdint.h>
#include <sys/neutrino.h>
#include <sys/syspage.h>
#include <inttypes.h>


int main (int argc, char *argv[])
{
    int    c;
    char   *dstr = NULL;
    int    btime_sec, btime_nsec;

    while ( ( c = getopt( argc, argv, "s:" ) ) != -1 )
    {
        switch ( c )
        {
            case 's':
                dstr = optarg;
                break;
        }
    }

    btime_sec = SYSPAGE_ENTRY(qtime)->nsec / 1000000000;
    btime_nsec = SYSPAGE_ENTRY(qtime)->nsec / 1000000 % 1000;

    printf( "[%3d.%03d c.] %s \n",  btime_sec, btime_nsec, (dstr) ? dstr : "");

    return ( 0 );
}
