﻿### pci-attach

Подключиться к PCI устройству.

### Синтаксис
```pci-attach [-s] [-v Vendor -d ID] [-arD] [-S]]```

### Опции
- **-s**

  Выполнить сканирование шины PCI и вывести список устройств.

- **-v PCI_Vendor**
- **-d PCI_ID**

  Подключиться к PCI устройству с указанными идентификаторами Vendor и ID.

- **-a**

  Не отключаться от устройства. По умолчанию: отключиться от устройства после вывода назначенных ресурсов.

- **-r**

  Смапировать, считать и вывести значения из назначенных PCI устройству диапазонов памяти.

- **-D**

  Считать и вывести значения из конфигурационной области PCI устройства. 
 
- **-S**

  Вывести значения из логической базы данных ресурсов PCI сервера (см. rsrcdbmgr_*())
 
### Описание

Утилита *pci-attach* подключается к PCI устройству с помощью функции pci_attach() и выводит назначенные PCI устройству ресурсы: диапазоны памяти и IO, прерывание.

В отличие от утилиты *pci*, сканирующей шину PCI и выводящей информацию из конфигурационного пространства PCI, но не подключающейся к устройству, *pci-attach* подключается к устройству с заданием флагов инициализации PCI_INIT_ALL и при этом PCI сервер назначает ресурсы устройству, если это требуется.

### Предостережения

Если к PCI устройству уже выполнено подключение из драйвера или какой-либо другой программы, то повторное подключение может привести к нарушению их работы.

### Примеры

Подключиться к PCI устройству с идентификаторами 0x8086:0x1533 и вывести назначенные устройству PCI ресурсы:


```pci-attach -v 0x8086 -d 0x1533```

Сканировать шину PCI:


```pci-attach -s```
