/*
 * Read/Write registers
 *
 * (c) 2005, SWD Embedded Systems Limited, http://www.kpda.ru
 */


#include <stdio.h>
#include <unistd.h>
#include <stdint.h>
#include <stdlib.h>
#include <hw/inout.h>
#include <sys/mman.h>
#include <sys/neutrino.h>


int main( int argc, char **argv )
{
    unsigned long long  port;
    int                 i,
                        num;
    unsigned            val;
    uintptr_t           base;

    if ( argc < 3 || argc > 4 )
    {
        printf( " Provide correct arguments. E.g. : rr 0x1000000 1 \n" );
        return ( -1 );
    }

    port = strtoull( argv[1], NULL, 16 );
    num  = strtoul(  argv[2], NULL, 16 );

    printf( "\nRead %d dwords from 0x%0llX\n", num, port );

    // Allow IO operations
    if ( ThreadCtl( _NTO_TCTL_IO, 0 ) == -1 )
    {
        printf( "You must be root!" );
        return (-1);
    }

    if ( (base = mmap_device_io( num, port )) == MAP_DEVICE_FAILED )
    {
        perror( "mmap_device_io()" );
        return (-1);
    }

    for ( i = 0; i < num; i++ )
    {
        printf( " [0x%X]\t 0x%0X\n", i * 4, in32( base + i * 4 ) );
    }

    if ( argc == 4 )
    {
        val = strtoul( argv[3], NULL, 16 );
        printf( " Writing value 0x%0X -> 0x%0llX \n", val, port );
        out32( base, val );
    }

    return (0);
}
