﻿### spitest

Получение/установка конфигурации SPI и тестовый обмен с устройствами на шине.

### Синтаксис
```spitest <команда> <индекс_устройства> <чип_селект> [данные [данные]]```

### Команды
- **devinfo <индекс_устройства: /dev/spi>**
- **drvinfo <индекс_устройства: /dev/spi'>**
- **all <индекс_устройства: /dev/spi'> <cs: 0..3>**

  Считать конфигурацию SPI (режим, частоту).

- **setcfg <индекс_устройства: /dev/spi'> <cs: 0..3> <режим> <частота>**

  Установить конфигурацию SPI (режим, частота).

- **io <индекс_устройства: /dev/spi'> <cs: 0..3> <размер_данных>**
- **iotext <индекс_устройства: 0='/dev/spi' / 1='/dev/spi1'> <cs: 0..3> <размер_данных> <данные>**
- **stdio <индекс_устройства: /dev/spi'> <cs: 0..3> <размер_данных>**

  Отправить в SPI устройство строку с данными и считать ответ.

  io: отправить команду чтения идентификатора флеш-памяти 0x9F.

  iotext: отправить произвольную строку символов.

  stdio: отправить последовательно увеличивающийся счётчик (00 01 02 и т. д.).


 
### Описание

Утилита *spitest* содержит пример получения и установки конфигурации SPI (режим, частота) и примеры тестового обмена данными с устройствами на шине.

Для команд обмена (io, iotext, stdio) предполагается наличие устройства на шине SPI.

### Примеры

Считать с шины /dev/spi1 идентификатор подключенной SPI флеш-памяти, отправив команду 0x9F:


```spitest io 1 0 4```


Отправить в устройство /dev/spi1 строку из четырёх байт и считать ответ:


```spitest iotext 1 0 4 1234```
